<?php

/**
 * @file 
 * Rules configuration forms for Signup Status Rules module
 *
 * @ingroup rules
 */

/**
 * Form for checking a signup status.
 */
function signup_status_rules_condition_status_has_value_form($settings, &$form) {
  $form['settings']['signup_status'] = _signup_status_rules_status_form($settings);
}

/**
 * Form for setting a signup status.
 */
function signup_status_rules_set_status_form($settings, &$form) {
  $form['settings']['signup_status'] = _signup_status_rules_status_form($settings);
}

/**
 * Helper function for building a status form.
 */
function _signup_status_rules_status_form($settings) {
  $statuses = signup_status_rules_get_statuses();
  foreach ($statuses as $sid => $status) {
    $options[$sid] = $status->name;
  }
  $settings += array('status' => array());
  return array(
    '#type' => 'select',
    '#title' => t('Updated status'),
    '#options' => $options,
    '#multiple' => FALSE,
    '#default_value' => isset($settings['status']) ? $settings['status'] : array(),
    '#required' => TRUE,
  );
}

/**
 * Get available signup statuses
 */
function signup_status_rules_get_statuses() {
  static $statuses = array();
  if (empty($statuses)) {
    $result = db_query("SELECT * FROM {signup_status_codes} ORDER BY weight");
    while ($status = db_fetch_object($result)) {
      $statuses[$status->cid] = $status;
    }
  }
  return $statuses;
}
